// Code generated by smithy-go-codegen DO NOT EDIT.

package bedrockagent

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/bedrockagent/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Retrieve a list of an agent's collaborators.
func (c *Client) ListAgentCollaborators(ctx context.Context, params *ListAgentCollaboratorsInput, optFns ...func(*Options)) (*ListAgentCollaboratorsOutput, error) {
	if params == nil {
		params = &ListAgentCollaboratorsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListAgentCollaborators", params, optFns, c.addOperationListAgentCollaboratorsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListAgentCollaboratorsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListAgentCollaboratorsInput struct {

	// The agent's ID.
	//
	// This member is required.
	AgentId *string

	// The agent's version.
	//
	// This member is required.
	AgentVersion *string

	// The maximum number of agent collaborators to return in one page of results.
	MaxResults *int32

	// Specify the pagination token from a previous request to retrieve the next page
	// of results.
	NextToken *string

	noSmithyDocumentSerde
}

type ListAgentCollaboratorsOutput struct {

	// A list of collaborator summaries.
	//
	// This member is required.
	AgentCollaboratorSummaries []types.AgentCollaboratorSummary

	// Specify the pagination token from a previous request to retrieve the next page
	// of results.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListAgentCollaboratorsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListAgentCollaborators{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListAgentCollaborators{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListAgentCollaborators"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addSpanRetryLoop(stack, options); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpListAgentCollaboratorsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListAgentCollaborators(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	if err = addSpanInitializeStart(stack); err != nil {
		return err
	}
	if err = addSpanInitializeEnd(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestStart(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestEnd(stack); err != nil {
		return err
	}
	return nil
}

// ListAgentCollaboratorsPaginatorOptions is the paginator options for
// ListAgentCollaborators
type ListAgentCollaboratorsPaginatorOptions struct {
	// The maximum number of agent collaborators to return in one page of results.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListAgentCollaboratorsPaginator is a paginator for ListAgentCollaborators
type ListAgentCollaboratorsPaginator struct {
	options   ListAgentCollaboratorsPaginatorOptions
	client    ListAgentCollaboratorsAPIClient
	params    *ListAgentCollaboratorsInput
	nextToken *string
	firstPage bool
}

// NewListAgentCollaboratorsPaginator returns a new ListAgentCollaboratorsPaginator
func NewListAgentCollaboratorsPaginator(client ListAgentCollaboratorsAPIClient, params *ListAgentCollaboratorsInput, optFns ...func(*ListAgentCollaboratorsPaginatorOptions)) *ListAgentCollaboratorsPaginator {
	if params == nil {
		params = &ListAgentCollaboratorsInput{}
	}

	options := ListAgentCollaboratorsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListAgentCollaboratorsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListAgentCollaboratorsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListAgentCollaborators page.
func (p *ListAgentCollaboratorsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListAgentCollaboratorsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.ListAgentCollaborators(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

// ListAgentCollaboratorsAPIClient is a client that implements the
// ListAgentCollaborators operation.
type ListAgentCollaboratorsAPIClient interface {
	ListAgentCollaborators(context.Context, *ListAgentCollaboratorsInput, ...func(*Options)) (*ListAgentCollaboratorsOutput, error)
}

var _ ListAgentCollaboratorsAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opListAgentCollaborators(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListAgentCollaborators",
	}
}
