// Code generated by smithy-go-codegen DO NOT EDIT.

package cleanrooms

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/cleanrooms/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Returns a list of ID namespace associations.
func (c *Client) ListIdNamespaceAssociations(ctx context.Context, params *ListIdNamespaceAssociationsInput, optFns ...func(*Options)) (*ListIdNamespaceAssociationsOutput, error) {
	if params == nil {
		params = &ListIdNamespaceAssociationsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListIdNamespaceAssociations", params, optFns, c.addOperationListIdNamespaceAssociationsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListIdNamespaceAssociationsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListIdNamespaceAssociationsInput struct {

	// The unique identifier of the membership that contains the ID namespace
	// association that you want to view.
	//
	// This member is required.
	MembershipIdentifier *string

	// The maximum size of the results that is returned per call. Service chooses a
	// default if it has not been set. Service may return a nextToken even if the
	// maximum results has not been met.
	MaxResults *int32

	// The pagination token that's used to fetch the next set of results.
	NextToken *string

	noSmithyDocumentSerde
}

type ListIdNamespaceAssociationsOutput struct {

	// The summary information of the ID namespace associations that you requested.
	//
	// This member is required.
	IdNamespaceAssociationSummaries []types.IdNamespaceAssociationSummary

	// The token value provided to access the next page of results.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListIdNamespaceAssociationsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListIdNamespaceAssociations{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListIdNamespaceAssociations{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListIdNamespaceAssociations"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addSpanRetryLoop(stack, options); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpListIdNamespaceAssociationsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListIdNamespaceAssociations(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	if err = addSpanInitializeStart(stack); err != nil {
		return err
	}
	if err = addSpanInitializeEnd(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestStart(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestEnd(stack); err != nil {
		return err
	}
	return nil
}

// ListIdNamespaceAssociationsPaginatorOptions is the paginator options for
// ListIdNamespaceAssociations
type ListIdNamespaceAssociationsPaginatorOptions struct {
	// The maximum size of the results that is returned per call. Service chooses a
	// default if it has not been set. Service may return a nextToken even if the
	// maximum results has not been met.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListIdNamespaceAssociationsPaginator is a paginator for
// ListIdNamespaceAssociations
type ListIdNamespaceAssociationsPaginator struct {
	options   ListIdNamespaceAssociationsPaginatorOptions
	client    ListIdNamespaceAssociationsAPIClient
	params    *ListIdNamespaceAssociationsInput
	nextToken *string
	firstPage bool
}

// NewListIdNamespaceAssociationsPaginator returns a new
// ListIdNamespaceAssociationsPaginator
func NewListIdNamespaceAssociationsPaginator(client ListIdNamespaceAssociationsAPIClient, params *ListIdNamespaceAssociationsInput, optFns ...func(*ListIdNamespaceAssociationsPaginatorOptions)) *ListIdNamespaceAssociationsPaginator {
	if params == nil {
		params = &ListIdNamespaceAssociationsInput{}
	}

	options := ListIdNamespaceAssociationsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListIdNamespaceAssociationsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListIdNamespaceAssociationsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListIdNamespaceAssociations page.
func (p *ListIdNamespaceAssociationsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListIdNamespaceAssociationsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.ListIdNamespaceAssociations(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

// ListIdNamespaceAssociationsAPIClient is a client that implements the
// ListIdNamespaceAssociations operation.
type ListIdNamespaceAssociationsAPIClient interface {
	ListIdNamespaceAssociations(context.Context, *ListIdNamespaceAssociationsInput, ...func(*Options)) (*ListIdNamespaceAssociationsOutput, error)
}

var _ ListIdNamespaceAssociationsAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opListIdNamespaceAssociations(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListIdNamespaceAssociations",
	}
}
