// Code generated by smithy-go-codegen DO NOT EDIT.

package cleanroomsml

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/cleanroomsml/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Returns a list of the trained models in a collaboration.
func (c *Client) ListCollaborationTrainedModels(ctx context.Context, params *ListCollaborationTrainedModelsInput, optFns ...func(*Options)) (*ListCollaborationTrainedModelsOutput, error) {
	if params == nil {
		params = &ListCollaborationTrainedModelsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListCollaborationTrainedModels", params, optFns, c.addOperationListCollaborationTrainedModelsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListCollaborationTrainedModelsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListCollaborationTrainedModelsInput struct {

	// The collaboration ID of the collaboration that contains the trained models you
	// are interested in.
	//
	// This member is required.
	CollaborationIdentifier *string

	// The maximum size of the results that is returned per call.
	MaxResults *int32

	// The token value retrieved from a previous call to access the next page of
	// results.
	NextToken *string

	noSmithyDocumentSerde
}

type ListCollaborationTrainedModelsOutput struct {

	// The trained models in the collaboration that you requested.
	//
	// This member is required.
	CollaborationTrainedModels []types.CollaborationTrainedModelSummary

	// The token value used to access the next page of results.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListCollaborationTrainedModelsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListCollaborationTrainedModels{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListCollaborationTrainedModels{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListCollaborationTrainedModels"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addSpanRetryLoop(stack, options); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpListCollaborationTrainedModelsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListCollaborationTrainedModels(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	if err = addSpanInitializeStart(stack); err != nil {
		return err
	}
	if err = addSpanInitializeEnd(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestStart(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestEnd(stack); err != nil {
		return err
	}
	return nil
}

// ListCollaborationTrainedModelsPaginatorOptions is the paginator options for
// ListCollaborationTrainedModels
type ListCollaborationTrainedModelsPaginatorOptions struct {
	// The maximum size of the results that is returned per call.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListCollaborationTrainedModelsPaginator is a paginator for
// ListCollaborationTrainedModels
type ListCollaborationTrainedModelsPaginator struct {
	options   ListCollaborationTrainedModelsPaginatorOptions
	client    ListCollaborationTrainedModelsAPIClient
	params    *ListCollaborationTrainedModelsInput
	nextToken *string
	firstPage bool
}

// NewListCollaborationTrainedModelsPaginator returns a new
// ListCollaborationTrainedModelsPaginator
func NewListCollaborationTrainedModelsPaginator(client ListCollaborationTrainedModelsAPIClient, params *ListCollaborationTrainedModelsInput, optFns ...func(*ListCollaborationTrainedModelsPaginatorOptions)) *ListCollaborationTrainedModelsPaginator {
	if params == nil {
		params = &ListCollaborationTrainedModelsInput{}
	}

	options := ListCollaborationTrainedModelsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListCollaborationTrainedModelsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListCollaborationTrainedModelsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListCollaborationTrainedModels page.
func (p *ListCollaborationTrainedModelsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListCollaborationTrainedModelsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.ListCollaborationTrainedModels(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

// ListCollaborationTrainedModelsAPIClient is a client that implements the
// ListCollaborationTrainedModels operation.
type ListCollaborationTrainedModelsAPIClient interface {
	ListCollaborationTrainedModels(context.Context, *ListCollaborationTrainedModelsInput, ...func(*Options)) (*ListCollaborationTrainedModelsOutput, error)
}

var _ ListCollaborationTrainedModelsAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opListCollaborationTrainedModels(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListCollaborationTrainedModels",
	}
}
