// Code generated by smithy-go-codegen DO NOT EDIT.

package dataexchange

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/dataexchange/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// This operation returns information about all received data grants.
func (c *Client) ListReceivedDataGrants(ctx context.Context, params *ListReceivedDataGrantsInput, optFns ...func(*Options)) (*ListReceivedDataGrantsOutput, error) {
	if params == nil {
		params = &ListReceivedDataGrantsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListReceivedDataGrants", params, optFns, c.addOperationListReceivedDataGrantsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListReceivedDataGrantsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListReceivedDataGrantsInput struct {

	// The acceptance state of the data grants to list.
	AcceptanceState []types.AcceptanceStateFilterValue

	// The maximum number of results to be included in the next page.
	MaxResults *int32

	// The pagination token used to retrieve the next page of results for this
	// operation.
	NextToken *string

	noSmithyDocumentSerde
}

type ListReceivedDataGrantsOutput struct {

	// An object that contains a list of received data grant information.
	DataGrantSummaries []types.ReceivedDataGrantSummariesEntry

	// The pagination token used to retrieve the next page of results for this
	// operation.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListReceivedDataGrantsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListReceivedDataGrants{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListReceivedDataGrants{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListReceivedDataGrants"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addSpanRetryLoop(stack, options); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListReceivedDataGrants(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	if err = addSpanInitializeStart(stack); err != nil {
		return err
	}
	if err = addSpanInitializeEnd(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestStart(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestEnd(stack); err != nil {
		return err
	}
	return nil
}

// ListReceivedDataGrantsPaginatorOptions is the paginator options for
// ListReceivedDataGrants
type ListReceivedDataGrantsPaginatorOptions struct {
	// The maximum number of results to be included in the next page.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListReceivedDataGrantsPaginator is a paginator for ListReceivedDataGrants
type ListReceivedDataGrantsPaginator struct {
	options   ListReceivedDataGrantsPaginatorOptions
	client    ListReceivedDataGrantsAPIClient
	params    *ListReceivedDataGrantsInput
	nextToken *string
	firstPage bool
}

// NewListReceivedDataGrantsPaginator returns a new ListReceivedDataGrantsPaginator
func NewListReceivedDataGrantsPaginator(client ListReceivedDataGrantsAPIClient, params *ListReceivedDataGrantsInput, optFns ...func(*ListReceivedDataGrantsPaginatorOptions)) *ListReceivedDataGrantsPaginator {
	if params == nil {
		params = &ListReceivedDataGrantsInput{}
	}

	options := ListReceivedDataGrantsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListReceivedDataGrantsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListReceivedDataGrantsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListReceivedDataGrants page.
func (p *ListReceivedDataGrantsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListReceivedDataGrantsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.ListReceivedDataGrants(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

// ListReceivedDataGrantsAPIClient is a client that implements the
// ListReceivedDataGrants operation.
type ListReceivedDataGrantsAPIClient interface {
	ListReceivedDataGrants(context.Context, *ListReceivedDataGrantsInput, ...func(*Options)) (*ListReceivedDataGrantsOutput, error)
}

var _ ListReceivedDataGrantsAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opListReceivedDataGrants(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListReceivedDataGrants",
	}
}
