// Code generated by smithy-go-codegen DO NOT EDIT.

package glue

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Creates settings for a column statistics task.
func (c *Client) CreateColumnStatisticsTaskSettings(ctx context.Context, params *CreateColumnStatisticsTaskSettingsInput, optFns ...func(*Options)) (*CreateColumnStatisticsTaskSettingsOutput, error) {
	if params == nil {
		params = &CreateColumnStatisticsTaskSettingsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "CreateColumnStatisticsTaskSettings", params, optFns, c.addOperationCreateColumnStatisticsTaskSettingsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*CreateColumnStatisticsTaskSettingsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type CreateColumnStatisticsTaskSettingsInput struct {

	// The name of the database where the table resides.
	//
	// This member is required.
	DatabaseName *string

	// The role used for running the column statistics.
	//
	// This member is required.
	Role *string

	// The name of the table for which to generate column statistics.
	//
	// This member is required.
	TableName *string

	// The ID of the Data Catalog in which the database resides.
	CatalogID *string

	// A list of column names for which to run statistics.
	ColumnNameList []string

	// The percentage of data to sample.
	SampleSize float64

	// A schedule for running the column statistics, specified in CRON syntax.
	Schedule *string

	// Name of the security configuration that is used to encrypt CloudWatch logs.
	SecurityConfiguration *string

	// A map of tags.
	Tags map[string]string

	noSmithyDocumentSerde
}

type CreateColumnStatisticsTaskSettingsOutput struct {
	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationCreateColumnStatisticsTaskSettingsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsAwsjson11_serializeOpCreateColumnStatisticsTaskSettings{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsAwsjson11_deserializeOpCreateColumnStatisticsTaskSettings{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "CreateColumnStatisticsTaskSettings"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addSpanRetryLoop(stack, options); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpCreateColumnStatisticsTaskSettingsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opCreateColumnStatisticsTaskSettings(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	if err = addSpanInitializeStart(stack); err != nil {
		return err
	}
	if err = addSpanInitializeEnd(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestStart(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestEnd(stack); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opCreateColumnStatisticsTaskSettings(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "CreateColumnStatisticsTaskSettings",
	}
}
