// Code generated by smithy-go-codegen DO NOT EDIT.

package pcs

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/pcs/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Returns a list of all compute node groups associated with a cluster.
func (c *Client) ListComputeNodeGroups(ctx context.Context, params *ListComputeNodeGroupsInput, optFns ...func(*Options)) (*ListComputeNodeGroupsOutput, error) {
	if params == nil {
		params = &ListComputeNodeGroupsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListComputeNodeGroups", params, optFns, c.addOperationListComputeNodeGroupsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListComputeNodeGroupsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListComputeNodeGroupsInput struct {

	// The name or ID of the cluster to list compute node groups for.
	//
	// This member is required.
	ClusterIdentifier *string

	// The maximum number of results that are returned per call. You can use nextToken
	// to obtain further pages of results. The default is 10 results, and the maximum
	// allowed page size is 100 results. A value of 0 uses the default.
	MaxResults *int32

	// The value of nextToken is a unique pagination token for each page of results
	// returned. If nextToken is returned, there are more results available. Make the
	// call again using the returned token to retrieve the next page. Keep all other
	// arguments unchanged. Each pagination token expires after 24 hours. Using an
	// expired pagination token returns an HTTP 400 InvalidToken error.
	NextToken *string

	noSmithyDocumentSerde
}

type ListComputeNodeGroupsOutput struct {

	// The list of compute node groups for the cluster.
	//
	// This member is required.
	ComputeNodeGroups []types.ComputeNodeGroupSummary

	// The value of nextToken is a unique pagination token for each page of results
	// returned. If nextToken is returned, there are more results available. Make the
	// call again using the returned token to retrieve the next page. Keep all other
	// arguments unchanged. Each pagination token expires after 24 hours. Using an
	// expired pagination token returns an HTTP 400 InvalidToken error.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListComputeNodeGroupsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsAwsjson10_serializeOpListComputeNodeGroups{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsAwsjson10_deserializeOpListComputeNodeGroups{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListComputeNodeGroups"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addSpanRetryLoop(stack, options); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpListComputeNodeGroupsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListComputeNodeGroups(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	if err = addSpanInitializeStart(stack); err != nil {
		return err
	}
	if err = addSpanInitializeEnd(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestStart(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestEnd(stack); err != nil {
		return err
	}
	return nil
}

// ListComputeNodeGroupsPaginatorOptions is the paginator options for
// ListComputeNodeGroups
type ListComputeNodeGroupsPaginatorOptions struct {
	// The maximum number of results that are returned per call. You can use nextToken
	// to obtain further pages of results. The default is 10 results, and the maximum
	// allowed page size is 100 results. A value of 0 uses the default.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListComputeNodeGroupsPaginator is a paginator for ListComputeNodeGroups
type ListComputeNodeGroupsPaginator struct {
	options   ListComputeNodeGroupsPaginatorOptions
	client    ListComputeNodeGroupsAPIClient
	params    *ListComputeNodeGroupsInput
	nextToken *string
	firstPage bool
}

// NewListComputeNodeGroupsPaginator returns a new ListComputeNodeGroupsPaginator
func NewListComputeNodeGroupsPaginator(client ListComputeNodeGroupsAPIClient, params *ListComputeNodeGroupsInput, optFns ...func(*ListComputeNodeGroupsPaginatorOptions)) *ListComputeNodeGroupsPaginator {
	if params == nil {
		params = &ListComputeNodeGroupsInput{}
	}

	options := ListComputeNodeGroupsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListComputeNodeGroupsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListComputeNodeGroupsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListComputeNodeGroups page.
func (p *ListComputeNodeGroupsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListComputeNodeGroupsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.ListComputeNodeGroups(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

// ListComputeNodeGroupsAPIClient is a client that implements the
// ListComputeNodeGroups operation.
type ListComputeNodeGroupsAPIClient interface {
	ListComputeNodeGroups(context.Context, *ListComputeNodeGroupsInput, ...func(*Options)) (*ListComputeNodeGroupsOutput, error)
}

var _ ListComputeNodeGroupsAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opListComputeNodeGroups(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListComputeNodeGroups",
	}
}
