// Code generated by smithy-go-codegen DO NOT EDIT.

package taxsettings

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/taxsettings/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Retrieves the tax exemption of accounts listed in a consolidated billing
// family.
func (c *Client) ListTaxExemptions(ctx context.Context, params *ListTaxExemptionsInput, optFns ...func(*Options)) (*ListTaxExemptionsOutput, error) {
	if params == nil {
		params = &ListTaxExemptionsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListTaxExemptions", params, optFns, c.addOperationListTaxExemptionsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListTaxExemptionsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListTaxExemptionsInput struct {

	// The number of results you want in one response.
	MaxResults *int32

	// The token to retrieve the next set of results.
	NextToken *string

	noSmithyDocumentSerde
}

type ListTaxExemptionsOutput struct {

	// The token to retrieve the next set of results.
	NextToken *string

	// The tax exemption details map of accountId and tax exemption details.
	TaxExemptionDetailsMap map[string]types.TaxExemptionDetails

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListTaxExemptionsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListTaxExemptions{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListTaxExemptions{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListTaxExemptions"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addSpanRetryLoop(stack, options); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListTaxExemptions(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	if err = addSpanInitializeStart(stack); err != nil {
		return err
	}
	if err = addSpanInitializeEnd(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestStart(stack); err != nil {
		return err
	}
	if err = addSpanBuildRequestEnd(stack); err != nil {
		return err
	}
	return nil
}

// ListTaxExemptionsPaginatorOptions is the paginator options for ListTaxExemptions
type ListTaxExemptionsPaginatorOptions struct {
	// The number of results you want in one response.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListTaxExemptionsPaginator is a paginator for ListTaxExemptions
type ListTaxExemptionsPaginator struct {
	options   ListTaxExemptionsPaginatorOptions
	client    ListTaxExemptionsAPIClient
	params    *ListTaxExemptionsInput
	nextToken *string
	firstPage bool
}

// NewListTaxExemptionsPaginator returns a new ListTaxExemptionsPaginator
func NewListTaxExemptionsPaginator(client ListTaxExemptionsAPIClient, params *ListTaxExemptionsInput, optFns ...func(*ListTaxExemptionsPaginatorOptions)) *ListTaxExemptionsPaginator {
	if params == nil {
		params = &ListTaxExemptionsInput{}
	}

	options := ListTaxExemptionsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListTaxExemptionsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListTaxExemptionsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListTaxExemptions page.
func (p *ListTaxExemptionsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListTaxExemptionsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.ListTaxExemptions(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

// ListTaxExemptionsAPIClient is a client that implements the ListTaxExemptions
// operation.
type ListTaxExemptionsAPIClient interface {
	ListTaxExemptions(context.Context, *ListTaxExemptionsInput, ...func(*Options)) (*ListTaxExemptionsOutput, error)
}

var _ ListTaxExemptionsAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opListTaxExemptions(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListTaxExemptions",
	}
}
